using System;
using System.Collections.Generic;
using System.IO;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using TDCG;

namespace TDCG.Proportion
{
    public class Reset_Shoulder : IProportion
    {
        Dictionary<string, TPONode> nodes;
        public Dictionary<string, TPONode> Nodes { set { nodes = value; }}

        static float DegreeToRadian(float angle)
        {
           return (float)(Math.PI * angle / 180.0);
        }

        public void Execute()
        {
            TPONode node;

            ////|[Yɖ߂
            node = nodes["W_RightShoulder"];
            node.RotateZ2(DegreeToRadian(-15F));
            node = nodes["W_RightArm"];
            node.RotateZ2(DegreeToRadian(-17F));
            node = nodes["W_RightForeArm"];
            node.RotateZ2(DegreeToRadian(-8F));
            node = nodes["W_RightHand"];
            node.RotateZ2(DegreeToRadian(-5F));

            node = nodes["W_LeftShoulder"];
            node.RotateZ2(DegreeToRadian(15F));
            node = nodes["W_LeftArm"];
            node.RotateZ2(DegreeToRadian(17F));
            node = nodes["W_LeftForeArm"];
            node.RotateZ2(DegreeToRadian(8F));
            node = nodes["W_LeftHand"];
            node.RotateZ2(DegreeToRadian(5F));

            //ɉ]
            node = nodes["W_RightArm"];
            node.RotateZ2(DegreeToRadian(40F));
            node = nodes["W_LeftArm"];
            node.RotateZ2(DegreeToRadian(-40F));
        }
    }
}
